dnl This file is generated by Makefile.am or ../mkmi
dnl Local extensions macros to Autoconf.
dnl Copyright (C) 1994, 1995  Per Cederqvist and Inge Wallin
dnl
dnl This program is free software; you can redistribute it and/or modify
dnl it under the terms of the GNU General Public License as published by
dnl the Free Software Foundation; either version 2 of the License, or
dnl (at your option) any later version.
dnl 
dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl GNU General Public License for more details.
dnl 
dnl You should have received a copy of the GNU General Public License
dnl along with this program; if not, write to the Free Software
dnl Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
dnl
dnl
dnl
dnl Check if an option is acceptable to the C compiler in use
dnl
AC_DEFUN(KOM_COMPILER_CC_ACCEPTS,
[kom_safe=`echo "kom_cv_compiler_${CC}_accepts_$1" | tr '+./=\055' 'X____'`
AC_MSG_CHECKING([whether ${CC} accepts $1])
AC_CACHE_VAL($kom_safe,
[[kom_oldflags=$CFLAGS
CFLAGS="$CFLAGS $1"]
AC_TRY_LINK(,,
	[eval "$kom_safe=yes"],
	[eval "$kom_safe=no"])
[CFLAGS=$kom_oldflags]])dnl
AC_MSG_RESULT([`eval echo '$'$kom_safe`])
if test `eval echo '$'$kom_safe` = yes; then
  CFLAGS="$CFLAGS $1"
fi])dnl
dnl
dnl
dnl Check if an option is acceptable to the C++ compiler in use
dnl
AC_DEFUN(KOM_COMPILER_CXX_ACCEPTS,
[kom_safe=`echo "kom_cv_compiler_${CXX}_accepts_$1" | tr '+./=\055' 'X____'`
AC_MSG_CHECKING([whether ${CXX} accepts $1])
AC_CACHE_VAL($kom_safe,
[[kom_oldflags=$CXXFLAGS
CXXFLAGS="$CXXFLAGS $1"]
AC_TRY_LINK(,,
	[eval "$kom_safe=yes"],
	[eval "$kom_safe=no"])
[CXXFLAGS=$kom_oldflags]])dnl
AC_MSG_RESULT([`eval echo '$'$kom_safe`])
if test `eval echo '$'$kom_safe` = yes; then
  CXXFLAGS="$CXXFLAGS $1"
fi])dnl
dnl
dnl
dnl Check that "struct std::iterator" is available in <iterator>.
dnl The STL supplied with gcc-2.95.2 does contain a proper struct
dnl iterator, but it doesn't make it available when compiled with 
dnl gcc...
dnl
AC_DEFUN(KOM_STL_STRUCT_ITERATOR,
[AC_MSG_CHECKING([whether struct std::iterator<> is available in <iterator>])
AC_CACHE_VAL(kom_cv_stl_struct_iterator,
	AC_TRY_COMPILE([#include <iterator>],
		[class foo : public std::iterator<
			std::forward_iterator_tag, int, int, int*, int&>
		{
		public: foo();
		}
		foo bar;],
		[kom_cv_stl_struct_iterator=yes],
		[kom_cv_stl_struct_iterator=no]))
AC_MSG_RESULT([$kom_cv_stl_struct_iterator])
[if test $kom_cv_stl_struct_iterator = no; then]
  AC_DEFINE(NEED_STRUCT_ITERATOR)
[fi]])
dnl
dnl
dnl Find stuff about the Python installation.
dnl This sets PYTHON_BOOTMAKEFILE and PYTHON_INCLUDES.
dnl
AC_DEFUN(KOM_PYTHON_PATHS,
[[if test x$1 = x
then
    PYTHON_BOOTMAKEFILE=
    PYTHON_INCLUDES=
else]
    AC_MSG_CHECKING([for Python bootmakefile])
    AC_CACHE_VAL(kom_cv_prog_python_bootmakefile,
    [[cat > conftestpy.py << \EOF
import sys
import string

try:
    v="%d.%d" % (sys.version_info[0], sys.version_info[1])
except AttributeError:
    v=sys.version[:3]

pfx = [sys.prefix]
if sys.exec_prefix != sys.prefix:
    pfx.append(sys.exec_prefix)

print "kom_cv_prog_python_bootmakefile=%s/lib/python%s/%s" % (
	sys.exec_prefix, v, "config/Makefile.pre.in")
print "kom_cv_prog_python_includes=\"%s\"" % string.join(
    map(lambda p, v=v: "-I%s/include/python%s" % (p, v), pfx), " ")
EOF

    if $1 conftestpy.py > conftestpy.sh
    then
        . ./conftestpy.sh
    else]]
        AC_MSG_ERROR([cannot find python binary $1])
    [[fi]])
    AC_MSG_RESULT($kom_cv_prog_python_bootmakefile)
    AC_MSG_CHECKING([for Python include files])
    AC_MSG_RESULT($kom_cv_prog_python_includes)
    [PYTHON_BOOTMAKEFILE="$kom_cv_prog_python_bootmakefile"
    PYTHON_INCLUDES="$kom_cv_prog_python_includes"
fi]
AC_SUBST(PYTHON_BOOTMAKEFILE)
AC_SUBST(PYTHON_INCLUDES)
])dnl
dnl eof
# This file contains two macros from unix/tcl.m4 from the TCL 8.3.0
# distribution.  It may be used under the license conditions found in
# license.terms in that distribution.  That license is included
# verbatim below.  It only applies to this file (tcl.m4) in the kom++
# distribution.
#
# This file is only used while running configure. Its license does not
# affect the built programs.
#
#                                  Per Cederqvist, 2000-02-13

# The original license terms from license.terms:

# This software is copyrighted by the Regents of the University of
# California, Sun Microsystems, Inc., Scriptics Corporation,
# and other parties.  The following terms apply to all files associated
# with the software unless explicitly disclaimed in individual files.
# 
# The authors hereby grant permission to use, copy, modify, distribute,
# and license this software and its documentation for any purpose, provided
# that existing copyright notices are retained in all copies and that this
# notice is included verbatim in any distributions. No written agreement,
# license, or royalty fee is required for any of the authorized uses.
# Modifications to this software may be copyrighted by their authors
# and need not follow the licensing terms described here, provided that
# the new terms are clearly indicated on the first page of each file where
# they apply.
# 
# IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY
# FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
# ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
# DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
# THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
# IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
# NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
# MODIFICATIONS.
# 
# GOVERNMENT USE: If you are acquiring this software on behalf of the
# U.S. government, the Government shall have only "Restricted Rights"
# in the software and related documentation as defined in the Federal 
# Acquisition Regulations (FARs) in Clause 52.227.19 (c) (2).  If you
# are acquiring the software on behalf of the Department of Defense, the
# software shall be classified as "Commercial Computer Software" and the
# Government shall have only "Restricted Rights" as defined in Clause
# 252.227-7013 (c) (1) of DFARs.  Notwithstanding the foregoing, the
# authors grant the U.S. Government and others acting in its behalf
# permission to use and distribute the software in accordance with the
# terms specified in this license. 

# The rest is an almost verbatim copy of parts of the unix/tcl.m4 file
# from TCL 8.3.0.  Changes are marked with "ceder".

#------------------------------------------------------------------------
# SC_PATH_TCLCONFIG --
#
#	Locate the tclConfig.sh file and perform a sanity check on
#	the Tcl compile flags
#
# Arguments:
#	none
#
# Results:
#
#	Adds the following arguments to configure:
#		--with-tcl=...
#
#	Defines the following vars:
#		TCL_BIN_DIR	Full path to the directory containing
#				the tclConfig.sh file
#------------------------------------------------------------------------

AC_DEFUN(SC_PATH_TCLCONFIG, [
    #
    # Ok, lets find the tcl configuration
    # First, look for one uninstalled.
    # the alternative search directory is invoked by --with-tcl
    #

    if test x"${no_tcl}" = x ; then
	# we reset no_tcl in case something fails here
	no_tcl=true
	AC_ARG_WITH(tcl, [  --with-tcl              directory containing tcl configuration (tclConfig.sh)], with_tclconfig=${withval})
	AC_MSG_CHECKING([for Tcl configuration])
	AC_CACHE_VAL(ac_cv_c_tclconfig,[

	    # First check to see if --with-tclconfig was specified.
	    if test x"${with_tclconfig}" != x ; then
		if test -f "${with_tclconfig}/tclConfig.sh" ; then
		    ac_cv_c_tclconfig=`(cd ${with_tclconfig}; pwd)`
		else
		    AC_MSG_ERROR([${with_tclconfig} directory doesn't contain tclConfig.sh])
		fi
	    fi

	    # then check for a private Tcl installation
	    if test x"${ac_cv_c_tclconfig}" = x ; then
		for i in \
			../tcl \
			`ls -dr ../tcl[[8-9]].[[0-9]]* 2>/dev/null` \
			../../tcl \
			`ls -dr ../../tcl[[8-9]].[[0-9]]* 2>/dev/null` \
			../../../tcl \
			`ls -dr ../../../tcl[[8-9]].[[0-9]]* 2>/dev/null` ; do
		    if test -f "$i/unix/tclConfig.sh" ; then
			ac_cv_c_tclconfig=`(cd $i/unix; pwd)`
			break
		    fi
		done
	    fi

	    # check in a few common install locations
	    if test x"${ac_cv_c_tclconfig}" = x ; then
		for i in `ls -d ${prefix}/lib 2>/dev/null` \
			`ls -d /usr/local/lib 2>/dev/null` ; do
		    if test -f "$i/tclConfig.sh" ; then
			ac_cv_c_tclconfig=`(cd $i; pwd)`
			break
		    fi
		done
	    fi

	    # check in a few other private locations
	    if test x"${ac_cv_c_tcliconfig}" = x ; then
		for i in \
			${srcdir}/../tcl \
			`ls -dr ${srcdir}/../tcl[[8-9]].[[0-9]]* 2>/dev/null` ; do
		    if test -f "$i/unix/tclConfig.sh" ; then
		    ac_cv_c_tclconfig=`(cd $i/unix; pwd)`
		    break
		fi
		done
	    fi
	])

	if test x"${ac_cv_c_tclconfig}" = x ; then
	    # Was:
	    # TCL_BIN_DIR="# no Tcl configs found"
	    # AC_MSG_WARN(Can't find Tcl configuration definitions)
	    # exit 0
	    TCL_BIN_DIR=
	    AC_MSG_RESULT(none found)
	    # End of change. /ceder
	else
	    no_tcl=
	    TCL_BIN_DIR=${ac_cv_c_tclconfig}
	    AC_MSG_RESULT(found $TCL_BIN_DIR/tclConfig.sh)
	fi
    fi
])

#------------------------------------------------------------------------
# SC_LOAD_TCLCONFIG --
#
#	Load the tclConfig.sh file
#
# Arguments:
#	
#	Requires the following vars to be set:
#		TCL_BIN_DIR
#
# Results:
#
#	Subst the following vars:
#		TCL_BIN_DIR
#		TCL_SRC_DIR
#		TCL_LIB_FILE
#
#------------------------------------------------------------------------

AC_DEFUN(SC_LOAD_TCLCONFIG, [
    AC_MSG_CHECKING([for existence of $TCL_BIN_DIR/tclConfig.sh])

    if test -f "$TCL_BIN_DIR/tclConfig.sh" ; then
        AC_MSG_RESULT([loading])
	. $TCL_BIN_DIR/tclConfig.sh
    else
        AC_MSG_RESULT([file not found])
    fi

    #
    # The eval is required to do the TCL_DBGX substitution in the
    # TCL_LIB_FILE variable
    #

    eval TCL_LIB_FILE=${TCL_LIB_FILE}
    eval TCL_LIB_FLAG=${TCL_LIB_FLAG}

    AC_SUBST(TCL_BIN_DIR)
    AC_SUBST(TCL_SRC_DIR)
    AC_SUBST(TCL_LIB_FILE)
])

