import os
import sys
import pickle
import regex
import string

size_re = regex.compile("reading \([0-9][0-9]*\) by \([0-9][0-9]*\) GIF image")

def update(dbfile, images):
    err = 0
    try:
	f = open(dbfile, "r")
	m = pickle.load(f)
	f.close()
    except (IOError, EOFError):
	m = {}

    for img in images:
	f = os.popen("giftopnm -verbose %s 2>&1 >/dev/null" % (img),
		     "r")
	line = f.readline()
	if size_re.search(line) == -1:
	    sys.stderr.write(img + ": not a gif file\n")
	    sys.stderr.write(line)
	    err = 1
	else:
	    m[os.path.basename(img)] = tuple(map(string.atoi,
						 size_re.group(1, 2)))

    if err == 0:
	f = open(dbfile, "w")
	pickle.dump(m, f)
	f.close()

    return err

if __name__ == "__main__":
    if len(sys.argv) < 3:
	sys.stderr.write("usage: %s dbfile image ...\n")
	sys.exit(1)
    
    sys.exit(update(sys.argv[1], sys.argv[2:]))
